
if (!ZombieKeys.StringBundle)
	ZombieKeys.StringBundle = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService);
if (!ZombieKeys.Properties)
	ZombieKeys.Properties = ZombieKeys.StringBundle.createBundle("chrome://zombiekeys/locale/zombiekeys.properties");



var ZombieKeys_TabURIregexp = {
	get _thunderbirdRegExp() {
		delete this._thunderbirdRegExp;
		return this._thunderbirdRegExp = new RegExp("^http://zombiekeys.mozdev.org/");
	}
};

var ZombieKeys_TabURIopener = {

	openURLInTab: function (URL) {
		try {
			var sTabMode="";
			var tabmail;
			tabmail = document.getElementById("tabmail");
			if (!tabmail) {
				// Try opening new tabs in an existing 3pane window
				var mail3PaneWindow = Components.classes["@mozilla.org/appshell/window-mediator;1"]
										 .getService(Components.interfaces.nsIWindowMediator)
										 .getMostRecentWindow("mail:3pane");
				if (mail3PaneWindow) {
					tabmail = mail3PaneWindow.document.getElementById("tabmail");
					mail3PaneWindow.focus();
				}
			}
			if (tabmail) {
				sTabMode = (ZombieKeys.Util.Application() == "Thunderbird" && ZombieKeys.Util.Appver()>=3) ? "contentTab" : "3pane";
				tabmail.openTab(sTabMode,
				{contentPage: URL, clickHandler: "specialTabs.siteClickHandler(event, ZombieKeys_TabURIregexp._thunderbirdRegExp);"});
			}
			else
				window.openDialog("chrome://messenger/content/", "_blank",
								  "chrome,dialog=no,all", null,
			  { tabType: "contentTab", tabParams: {contentPage: URL, clickHandler: "specialTabs.siteClickHandler(event, ZombieKeys_TabURIregexp._thunderbirdRegExp);", id:"ZombieKeys_Weblink"} } );
		}
		catch(e) { return false; }
		return true;
	}
};


if (!ZombieKeys.Util)
	ZombieKeys.Util = {
	ZombieKeys_CURRENTVERSION : '2.5',
	ConsoleService: null,
    mAppver: null,
    mAppName: null,
    mHost: null,
    lastTime: 0,
    myVersion: null,

	getAddon: function(aId) {
		var em = Components.classes["@mozilla.org/extensions/manager;1"]
                  .getService(Components.interfaces.nsIExtensionManager);
		return em.getItemForID(aId);
	} ,

	Version: function() {
	    return this.myVersion
	    	   ?
	    	   this.myVersion
	    	   :
	    	   this.ZombieKeys_CURRENTVERSION;
	} ,

	// dedicated function for email clients which don't support tabs
	// and for secured pages (donation page).
	openLinkInBrowserForced: function(linkURI) {
		try {
			this.logDebug("openLinkInBrowserForced (" + linkURI + ")");
			if (ZombieKeys.Util.Application()=='SeaMonkey') {
				var windowManager = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService(Components.interfaces.nsIWindowMediator);
				browser = windowManager.getMostRecentWindow( "navigator:browser" );
				if (browser) {
					let URI = linkURI;
					setTimeout(function() {  browser.currentTab = browser.getBrowser().addTab(URI); browser.currentTab.reload(); }, 250);
				}
				else
					window.openDialog(getBrowserURL(), "_blank", "all,dialog=no", linkURI, null, 'ZombieKeys update');

				return;
			}
			var service = Components.classes["@mozilla.org/uriloader/external-protocol-service;1"]
				.getService(Components.interfaces.nsIExternalProtocolService);
			var ioservice = Components.classes["@mozilla.org/network/io-service;1"].
						getService(Components.interfaces.nsIIOService);
			var uri = ioservice.newURI(linkURI, null, null);
			service.loadURI(uri);
		}
		catch(e) { this.logDebug("openLinkInBrowserForced (" + linkURI + ") " + e.toString()); }
	},


	// moved from options.js
	// use this to follow a href that did not trigger the browser to open (from a XUL file)
	openLinkInBrowser: function(evt,linkURI) {
		if (ZombieKeys.Util.Appver()>=3 && ZombieKeys.Util.Application()=='Thunderbird') {
			var service = Components.classes["@mozilla.org/uriloader/external-protocol-service;1"]
				.getService(Components.interfaces.nsIExternalProtocolService);
			var ioservice = Components.classes["@mozilla.org/network/io-service;1"].
						getService(Components.interfaces.nsIIOService);
			service.loadURI(ioservice.newURI(linkURI, null, null));
			if(null!=evt)
				evt.stopPropagation();
		}
		else
			this.openLinkInBrowserForced(linkURI);
	},

	// moved from options.js (then called
	openURL: function(evt,URL) { // workaround for a bug in TB3 that causes href's not be followed anymore.
		var ioservice,iuri,eps;

		if (ZombieKeys.Util.Appver()<3 && ZombieKeys.Util.Application()=='Thunderbird'
			|| ZombieKeys.Util.Application()=='SeaMonkey'
			|| ZombieKeys.Util.Application()=='Postbox')
		{
			this.openLinkInBrowserForced(URL);
			if(null!=evt) evt.stopPropagation();
		}
		else {
			if (ZombieKeys_TabURIopener.openURLInTab(URL) && null!=evt) {
				if (evt.preventDefault) evt.preventDefault();
				if (evt.stopPropagation) evt.stopPropagation();
			}
		}
	},



	checkFirstRun: function() {
		ZombieKeys.Util.logDebug("checkFirstRun");
		var prev = -1, firstrun = true;
		var showFirsts = true, debugFirstRun = false;

		var svc = Components.classes["@mozilla.org/preferences-service;1"]
			.getService(Components.interfaces.nsIPrefService);
		var ssPrefs = svc.getBranch("extensions.ZombieKeys.");

		var current = ZombieKeys.Util.Version();
		ZombieKeys.Util.logDebug("Current ZombieKeys Version: " + current);
		try {
			ZombieKeys.Util.logDebugOptional ("firstRun","try to get setting: getCharPref(version)");
			try { prev = ssPrefs.getCharPref("version"); } catch (e) { prev = "?"; } ;

			ZombieKeys.Util.logDebugOptional ("firstRun","try to get setting: getBoolPref(firstrun)");
			try { firstrun = ssPrefs.getBoolPref("firstRun"); } catch (e) { firstrun = true; }

			// enablefirstruns=false - allows start pages to be turned off for partners
			ZombieKeys.Util.logDebugOptional ("firstRun","try to get setting: getBoolPref(enablefirstruns)");
			try { showFirsts = ssPrefs.getBoolPref("enablefirstruns"); } catch (e) { showFirsts = true; }


			ZombieKeys.Util.logDebugOptional ("firstRun", "Settings retrieved:"
					+ "\nprevious version=" + prev
					+ "\ncurrent version=" + current
					+ "\nfirstrun=" + firstrun
					+ "\nshowfirstruns=" + showFirsts
					+ "\ndebugFirstRun=" + debugFirstRun);

		}
		catch(e) {

			alert("Exception in ZombieKeys_util.js: " + e.message
				+ "\n\ncurrent: " + current
				+ "\nprev: " + prev
				+ "\nfirstrun: " + firstrun
				+ "\nshowFirstRuns: " + showFirsts
				+ "\ndebugFirstRun: " + debugFirstRun);

		}
		finally {
			ZombieKeys.Util.logDebugOptional ("firstRun","finally - firstrun=" + firstrun);

			// AG if this is a pre-release, cut off everything from "pre" on... e.g. 1.9pre11 => 1.9
			var pre=0;
			var pureVersion=current;
			if (0<(pre=current.indexOf('pre'))) {
				pureVersion = current.substring(0,pre);
			}
			ZombieKeys.Util.logDebugOptional ("firstRun","finally - pureVersion=" + pureVersion);
			// change this depending on the branch
			var versionPage = "http://ZombieKeys.mozdev.org/version.html#" + pureVersion;
			ZombieKeys.Util.logDebugOptional ("firstRun","finally - versionPage=" + versionPage);

			if (firstrun){
				ZombieKeys.Util.logDebugOptional ("firstRun","set firstRun=false and store version " + current);
				ssPrefs.setBoolPref("firstRun",false);
				ssPrefs.setCharPref("version",current); // store current (simplified) version!

				if (showFirsts) {
					// Insert code for first run here
					// on very first run, we go to the index page - welcome blablabla
					ZombieKeys.Util.logDebugOptional ("firstRun","setTimeout for content tab (index.html)");
					window.setTimeout(function() {
						ZombieKeys.Util.openURL(null, "http://ZombieKeys.mozdev.org/index.html");
					}, 1500); //Firefox 2 fix - or else tab will get closed (leave it in....)

				}

			}
			else { // this section does not get loaded if its a fresh install.
				if (prev!=current) { // VERSION UPDATE!
					ZombieKeys.Util.logDebugOptional ("firstRun","prev!=current -> upgrade case.");
					// upgrade case!!
					ssPrefs.setCharPref("version",current);

					if (showFirsts) {
						// version is different => upgrade (or conceivably downgrade)
						ZombieKeys.Util.logDebugOptional ("firstRun","open tab for version history + browser for donation" + current);
						window.setTimeout(function(){
							// display version history
							ZombieKeys.Util.openURL(null, versionPage);

// 							// display donation page (can be disabled; I will send out method to all donators and anyone who asks me for it)
// 							if ((ZombieKeys.Preferences.getBoolPrefQF("donateNoMore")))
// 								ZombieKeys.Util.logDebugOptional ("firstRun","Jump to donations page disabled by user");
// 							else
								ZombieKeys.Util.openURL("http://zombiekeys.mozdev.org/donate.html"); // show donation page!
						}, 1500); //Firefox 2 fix - or else tab will get closed
					}
				}
				else
					ZombieKeys.Util.logDebugOptional ("firstRun","prev!=current -> just a reload of same version - prev=" + prev + ", current = " + current);


			}

		}

	} ,


	checkVersionFirstRun: function() {
		var aId = "zombiekeys@bolay.de";
		if(!Components.classes["@mozilla.org/extensions/manager;1"])
		{
			Components.utils.import("resource://gre/modules/AddonManager.jsm");
			setTimeout (function () {
					AddonManager.getAddonByID(aId,
						function(addon) {
							// This is an asynchronous callback function that might not be called immediately, ah well...
							ZombieKeys.Util.myVersion = addon.version;
							ZombieKeys.Util.logDebug("AddonManager retrieved Version number: " + addon.version);
							ZombieKeys.Util.checkFirstRun();
						}
					);
			    }, 0);
	    }
	    else {
	    	ZombieKeys.Util.myVersion = this.getAddon(aId).version;
			ZombieKeys.Util.logDebug("Retrieved Version number from nsIExtensionManager (legacy): " + ZombieKeys.Util.myVersion);
			ZombieKeys.Util.checkFirstRun();
    	}
    },



	AppverFull: function() {
		var appInfo = Components.classes["@mozilla.org/xre/app-info;1"]
		                .getService(Components.interfaces.nsIXULAppInfo);
		return appInfo.version;
    },

    Appver: function() {
        if (null == this.mAppver) {
	    var appVer=this.AppverFull().substr(0,3); // only use 1st three letters - that's all we need for compatibility checking!
		    this.mAppver = parseFloat(appVer); // quick n dirty!
        }
		return this.mAppver;
    },

    Application: function() {
		if (null==this.mAppName) {
        var appInfo = Components.classes["@mozilla.org/xre/app-info;1"]
                        .getService(Components.interfaces.nsIXULAppInfo);
			const FIREFOX_ID = "{ec8030f7-c20a-464f-9b0e-13a3a9e97384}";
			const THUNDERBIRD_ID = "{3550f703-e582-4d05-9a08-453d09bdfdc6}";
			const SEAMONKEY_ID = "{92650c4d-4b8e-4d2a-b7eb-24ecf4f6b63a}";
			const POSTBOX_ID = "postbox@postbox-inc.com";
			switch(appInfo.ID) {
				case FIREFOX_ID:
				  return this.mAppName='Firefox';
				case THUNDERBIRD_ID:
				  return this.mAppName='Thunderbird';
				case SEAMONKEY_ID:
				  return this.mAppName='SeaMonkey';
				case POSTBOX_ID:
				  return this.mAppName='Postbox';
				default:
				  this.mAppName=appInfo.name;
				  this.logDebug ( 'Unknown Application: ' + appInfo.name);
				  return appInfo.name;
			}
        }
	    return this.mAppName;
    },

    HostSystem: function() {
		if (null==this.mHost) {
			var osString = Components.classes["@mozilla.org/xre/app-info;1"]
		                .getService(Components.interfaces.nsIXULRuntime).OS;
			this.mHost = osString.toLowerCase();
        }
        return this.mHost; // linux - winnt - darwin
    },


    logTime: function() {
	    var timePassed = '';
	    try {
		    var end= new Date();
		    var endTime = end.getTime();
			var elapsed = new String(endTime  - this.lastTime); // time in milliseconds
			timePassed = '[' + elapsed + ' ms]   ';
		    this.lastTime = endTime; // remember last time
        }
        catch(e) {;}
	    return end.getHours() + ':' + end.getMinutes() + ':' + end.getSeconds() + '.' + end.getMilliseconds() + '  ' + timePassed;
    },

    logToConsole: function (msg) {
	  if (this.ConsoleService == null)
	    this.ConsoleService = Components.classes["@mozilla.org/consoleservice;1"]
	                               .getService(Components.interfaces.nsIConsoleService);
	  this.ConsoleService.logStringMessage("ZombieKeys " + this.logTime() + "\n"+ msg);
	},

    logDebug: function (msg) {
	  if (ZombieKeys.Preferences.isDebug())
	    this.logToConsole(msg);
	},

    logDebugOptional: function (option, msg) {
	  if (ZombieKeys.Preferences.isDebugOption(option))
	    this.logToConsole(msg);
	},

	showAboutConfig: function(filter) {

		const name = "Preferences:ConfigManager";
		const uri = "chrome://global/content/config.xul";

		var mediator = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
		var w = mediator.getMostRecentWindow(name);

		if (!w) {
			var watcher = Components.classes["@mozilla.org/embedcomp/window-watcher;1"].getService(Components.interfaces.nsIWindowWatcher);
			w = watcher.openWindow(null, uri, name, "chrome,resizable,centerscreen,width=500px,height=350px", null);
		}
		w.focus();
		w.setTimeout(
			function () {
				var flt = w.document.getElementById("textbox");
				if (flt) {
					 flt.value=filter;
					 flt.focus();
					 if (w.self.FilterPrefs)
					 w.self.FilterPrefs();
				}
			}, 300);
	},

	showVersionHistory: function(label, ask) {
		var pre=0;
		var current=label.value.toString();  // retrieve version number from label
		var pureVersion = current;
		if (0<(pre=current.indexOf('pre'))) {   // make sure to strip off any pre release labels
			pureVersion = current.substring(0,pre);
		}

		var sPrompt = ZombieKeys.Util.getBundleString("confirmVersionLink", "Display version history for ZombieKeys")
		if (!ask || confirm(sPrompt + " " + pureVersion + "?")) {
			ZombieKeys.Util.openURL(null, "http://zombiekeys.mozdev.org/version.html" + "#" + pureVersion);
		}
	}

};





